module CurryCoreSyntax where


import CommonSyntax(Annotation)


type CCProgram = CCExpr


---------- expressions ---------------------------------------------------------------------------

data CCExpr =
     CCExprLet      [CCFunDef]     CCExpr
   | CCExprFreeDecl CCVariable     CCExpr
   | CCExprLambda   CCVariable     CCExpr
   | CCExprCase     Annotation	   CCVariable     [CCAlternative]
   | CCExprAppl     CCExpr         CCVariable
   | CCExprVar      CCVariable
   | CCExprConstr   CCDataConstr   [CCVariable]
   -- we want the builtin operators explicit
   | CCExprAnd      CCExpr         CCExpr
   | CCExprOr	    CCExpr	   CCExpr
   | CCExprUnify    CCExpr	   CCExpr
   | CCExprGuard    CCExpr	   CCExpr
   | CCExprStrict   CCExpr
   | CCExprFail
   | CCExprError    CCError
   deriving (Eq)

data CCError =
     CCErrorPatternDecl
     deriving (Eq)


---------- function definition -------------------------------------------------------------------

data CCFunDef = 
     CCFunDef       CCVariable     CCExpr
     deriving (Eq)

---------- alternative ---------------------------------------------------------------------------

data CCAlternative =
     CCAlternative  CCDataConstr   [CCVariable]   CCExpr
     deriving (Eq)


---------- names ---------------------------------------------------------------------------------

newtype CCName = CCName String
	deriving (Eq)

data CCVariable    = CCVariable  CCVariableId     -- tag
     deriving (Show, Eq) -- for debugging

data CCDataConstr  = CCDataConstr CCName CCConstrId CCArity -- tag arity TODO name, aritt notwendig???
     deriving (Eq)

type CCVariableId = Int
type CCConstrId   = Int
type CCArity      = Int

