module ErrorMonad where

data MaybeError a = Error String | NullProblemo a

instance Functor MaybeError where
   fmap _ (Error e)        = Error e
   fmap f (NullProblemo a) = NullProblemo (f a)

instance Monad MaybeError where
   Error e        >>= _  =  Error e
   NullProblemo a >>= k  =  k a

   fail   = Error
   return = NullProblemo

-- lifting MaybeError to IO
maybeErrorToIO :: MaybeError a -> IO a
maybeErrorToIO (Error e)        = ioError (userError e)
maybeErrorToIO (NullProblemo a) = return a
