module MyPrelude
where

import Char

-- lists


accumulator _   []     = []
accumulator val (x:xs) = val : (accumulator (val + x) xs)




-- IO

getInt = do s <- getLine
	    let multiplier n = n : (multiplier (n*10))
		s' = filter isDigit s
	    return $ foldr (\ (m1,m2) v -> v + (m1*m2)) 0 (zip (multiplier 1) (map digitToInt $ reverse s'))


ioIf if' then' = if if' then then' else return ()




-- shows

showsSepBy :: Show a => String -> [a] -> ShowS
showsSepBy _   []     = showString ""
showsSepBy _   [x]    = shows x
showsSepBy sep (x:xs) = shows x . showString sep . showsSepBy sep xs



-- own monad utilities

concatMapM :: Monad m => (a -> m [b]) -> [a] -> m [b]
concatMapM f xs = do xs' <- mapM f xs
 		     return (concat xs')


partitionM _    []     = return ([],[])
partitionM pred (x:xs) = do res <- pred x
			    (yes,no) <- partitionM pred xs
			    return $ if res then (x:yes,no)
					    else (yes,x:no)

ifThenElseM if' then' else' = do res <- if'
				 if res then then' else else'


