module Queue
where

import TraceClass

data Queue a = Queue [a] [a]

emptyQueue = Queue [] []

enqueue (Queue inQ outQ) ele = Queue (ele:inQ) outQ

dequeue (Queue [] [])  = error "Queue.dequeue: empty queue!\n"
dequeue (Queue inQ []) = dequeue $ Queue [] (reverse inQ)
dequeue (Queue inQ (ele:outQ)) = (Queue inQ outQ, ele)


dequeueWithDefault (Queue [] [])  def = (emptyQueue, def)
dequeueWithDefault (Queue inQ []) _   = dequeue $ Queue [] (reverse inQ)
dequeueWithDefault (Queue inQ (ele:outQ)) _ = (Queue inQ outQ, ele)

isQueueEmpty (Queue [] []) = True
isQueueEmpty _ = False

instance (Trace a) => Trace (Queue a) where
   trace (Queue [] []) = 
      putStr "Queue is empty."
   trace (Queue inQ outQ) = 
      traceSepSpace (reverse inQ ++ outQ)