module Stack
where

import TraceClass

data Stack a = Stack [a]

top (Stack []) = error "stack.top: empty stack!\n"
top (Stack s)  = head s


pop (Stack []) = error "stack.pop: empty stack!\n"
pop (Stack s)  = Stack $ tail s

push (Stack s) ele = Stack (ele:s)

emptyStack = Stack []

isEmptyStack (Stack []) = True
isEmptyStack _		= False


instance (Trace a) => Trace (Stack a) where
   trace (Stack s) = let n = length s
		     in  if n == 0 then
			   putStrLn "Empty Stack"
			 else
			   do putStrLn $ "Stack size: " ++ show (length s)
			      putStrLn "Top Element:"
			      trace (head s)
