-- -*- haskell -*- 
{  
module ParserDefinition(Definitions, parseDefinition')
where

import Scanner(Token(..))
import FiniteMap
} 


%name parseDefinition
%tokentype { Token }
%token  NAME	    { TokenName $$    }
	TEXOUT      { TokenTexRepresentation $$ }
	"%%"	    { TokenStart }
%%

definitionfile :: { Definitions }
   : definitions "%%" { listToFM $1 }

definitions :: { [Definition] }
   : definition             { [$1] }
   | definition definitions { $1 : $2 }

definition :: { Definition }
   : NAME TEXOUT            { ($1, tidy $2) }

{ 

type Definitions = FiniteMap String String

type Definition = (String, String)

tidy :: String -> String
tidy d = (delLast (delFirstSpaces (tail $ tail d)))

delFirstSpaces (' ':r) = delFirstSpaces r
delFirstSpaces ('\t':r) = delFirstSpaces r
delFirstSpaces s = s

delLast [_] = []
delLast (x:xs) = x:(delLast xs)
delLast [] = []

parseDefinition' ts = return $ parseDefinition ts

happyError t = error $ "ParseDefinition: Fehler nahe " ++ (show (take 5 t)) ++ "\n"
}
