% -*- prolog -*-


emptyHeap([]).


addBinding(Heap, [P,E], [[P,E] | Heap_]) :-
   (myMember([P,E_], Heap) ->
      myDelete(Heap,[P,E_],Heap_)
      ;
      Heap_ = Heap).

addBindings(Heap, [], Heap).
addBindings(Heap, [B|Bs], Heap_) :-
   addBinding(Heap,    B,  Heap__),
   addBindings(Heap__, Bs, Heap_).

initializeVar(Heap, P, Heap_) :-
   addBinding(Heap, [P,nil], Heap_).

initializeVars(Heap, [], Heap).
initializeVars(Heap, [P|Ps], Heap_) :-
   initializeVar(Heap, P, Heap__),
   initializeVars(Heap__, Ps, Heap_).

lookupBinding(Heap, P, E) :-
   myMember([P,E], Heap).

removeBinding(Heap, P, Heap_) :-
   myMember([P,E], Heap),
   myDelete(Heap, [P,E], Heap_).


% durch den heap induzierte substitution

inducedSubst([],[]).
inducedSubst([B|Heap], [B_|HeapSigma]) :-
   inducedBinding(B,B_),
   inducedSubst(Heap,HeapSigma).

inducedBinding([P, lambda(_,_)], [P, constr(function, [])]) :- !.
inducedBinding([P, nil], [P, P]) :- !.
inducedBinding(B,B).
