% -*- prolog -*-

zip([],[],[]).
zip([E1|R1], [E2|R2], [[E1,E2]|R]) :-
   zip(R1,R2,R).

zip3([],[],[]).
zip3([E1|R1], [E2|R2], [E3|R3], [[E1,E2,E3]|R]) :-
   zip3(R1,R2,R3,R).

deleteList(In, [], In).
deleteList(In, [E|Es], Out) :-
   myDelete(In, E, Out_),
   deleteList(Out_, Es, Out).

myDelete([], _, []).
myDelete([Head|Tail], Element, Rest) :-
	Head==Element, !,
        myDelete(Tail, Element, Rest).
myDelete([Head|Tail], Element, [Head|Rest]) :-
        myDelete(Tail, Element, Rest).

removeDups([], []).
removeDups([Head|Tail1], [Head|Tail2]) :-
        myDelete(Tail1, Head, Residue),
        removeDups(Residue, Tail2).

myMember(Element, [Element|_]).
myMember(Element, [_|Tail]) :-
	myMember(Element,Tail).

myAppend([], List, List).
myAppend([Head|Tail], List, [Head|Rest]) :-
        myAppend(Tail, List, Rest).
